import {
  REQUEST,
  RESPONSE_SUCCESS,
  RESPONSE_FAIL,
  SUBSCRIBE,
  UNSUBSCRIBE
} from './document-actions'

export default (doc = {
  data: null,
  isFetching: false,
  didInvalidate: false,
  error: null,
}, action) => {
  switch(action.type) {
    /*
    case INVALIDATE_USER:
      return Object.assign({}, user, {
        didInvalidate: true,
        error: null
      })
      */
    case REQUEST(action.options):
      return Object.assign({}, doc, {
        isFetching: true,
        didInvalidate: false,
        error: null
      })
    case RESPONSE_SUCCESS(action.options):
      return Object.assign({}, doc, {
        data: action.result,
        isFetching: false,
        didInvalidate: false,
        error: null
      })
    case RESPONSE_FAIL(action.options):
      return Object.assign({}, doc, {
        data: null,
        isFetching: false,
        didInvalidate: false,
        error: action.error
      })
    case SUBSCRIBE(action.options):
      return Object.assign({}, doc, {
        unsubscribe: action.unsubscribe
      })
    case UNSUBSCRIBE(action.options):
      if(doc.unsubscribe) {
        doc.unsubscribe()
      }
      return Object.assign({}, doc, {
        unsubscribe: null
      })
    default:
      return doc
  }
}
